module BMC::FormHelper
  include BMC::I18nHelper

  # Hidden submit to be the default triggered on <enter> keypress on a form
  # Does not work if display:none
  def form_hidden_submit
    css = "position:absolute;top:-9999px;left:-9999px;opacity:0;height:0;width:0;visibility: hidden"
    tag(:input, type: "submit", class: "hidden-submit", style: css)
  end

  def search_form(action: request.fullpath)
    render "bmc/search/form", action: action
  end

  def hidden_inputs_for_get_form(url, except: [])
    query_values = Addressable::URI.parse(url).query_values.to_h
      .with_indifferent_access
      .except(*except)

    return if query_values.empty?

    query_values.sum("".html_safe) { |k, v| tag.input(type: "hidden", name: k, value: v) }
  end
end
