require "awesome_print"
require "pry-rails"
require "rails-i18n"
require "nilify_blanks"
require "tapenade"
require "attr_extras/explicit"

module BMC
  class Engine < ::Rails::Engine
    isolate_namespace BMC

    initializer "inflections" do
      ActiveSupport::Inflector.inflections(:en) do |inflect|
        inflect.acronym "BMC"
        inflect.acronym "SMS"
        inflect.acronym "UUID"
        inflect.acronym "XLSX"
      end
    end

    initializer "bmc_mime_types" do
      Mime::Type.register "application/vnd.ms-excel", :xls
      Mime::Type.register "application/vnd.ms-excel", :xlsx
    end

    # initializer "bmc_errors_middleware" do
    #   require "bmc/errors_middleware"
    # end
  end
end

require_relative "config"
require_relative "engine_file"
require_relative "core_and_rails_ext"
